// Fichier libre de droits

#include <fstream>
#include <string>
#include "ContenuFichier.h"
#include "Exceptions.h"

ContenuFichier::Point::Point(int l, int c) {
	ligne = l;
	colonne = c;
}

ContenuFichier::ContenuFichier(const char *filename, bool allowHexagonal) {
	hexagonal = false;
	std::ifstream inputFileStream;
	inputFileStream.open(filename);
	// Ne marche pas, et je ne sais pas pourquoi
	// Mais inutile de le laisser alors...
	//if ( ! inputFileStream) {
	//    std::string filename2(filename);
	//    inputFileStream.close();
	//    filename2 += ".txt";
	//    inputFileStream.open(filename2.c_str());
	//    if ( ! inputFileStream) {
	//        inputFileStream.close();
	//        throw CLoadingFailed(filename);
	//    }
	//}
	if ( ! inputFileStream) {
		inputFileStream.close();
		throw CLoadingFailed(filename);
	}
	std::string ligneTexte;
	int ligne = 0;
	int colonne = 0;
	ligneMaximum = 0;
	colonneMaximum = 0;
	getline(inputFileStream, ligneTexte);
	if (allowHexagonal) {
		if (ligneTexte.size() == 4) {
			if ( ('h' == ligneTexte[0]) || ('H' == ligneTexte[0]) ) {
				if ( ('e' == ligneTexte[1]) || ('E' == ligneTexte[1]) ) {
					if ( ('x' == ligneTexte[2]) || ('X' == ligneTexte[2]) ) {
						if ( ('a' == ligneTexte[3]) || ('A' == ligneTexte[3]) ) {
							hexagonal = true;
						}
					}
				}
			}
		}
	}
	do {
		if (std::string::npos == ligneTexte.find_first_not_of(" xX.")) {
			for (std::string::const_iterator i = ligneTexte.begin(); i != ligneTexte.end(); ++i) {
				switch (*i) {
				case '.' :
					casesLibres.push_back(Point(ligne, colonne));
					if (ligne > ligneMaximum) {
						ligneMaximum = ligne;
					}
					if (colonne > colonneMaximum) {
						colonneMaximum = colonne;
					}
					break;
				case 'x' :
				case 'X' :
					if (ligne > ligneMaximum) {
						ligneMaximum = ligne;
					}
					if (colonne > colonneMaximum) {
						colonneMaximum = colonne;
					}
					casesOccupees.push_back(Point(ligne, colonne));
					break;
				}
				colonne += 1;
			}
			ligne += 1;
		}
		colonne = 0;
	} while ( getline(inputFileStream, ligneTexte) );
	inputFileStream.close();
}
