// Fichier libre de droits

#ifndef ENSEMBLEDECASES_H
#define ENSEMBLEDECASES_H

#include <iostream>
#include "Mouvement.h"

template<class ImplementationInterne>
struct EnsembleDeCases : public ImplementationInterne {
	EnsembleDeCases();
	EnsembleDeCases(const EnsembleDeCases &);
	EnsembleDeCases& operator=(const EnsembleDeCases &);
	bool appliqueMouvement(const Mouvement<typename ImplementationInterne::Point> &);
	void retireMouvement(const Mouvement<typename ImplementationInterne::Point> &);
};

template<class ImplementationInterne>
EnsembleDeCases<ImplementationInterne>::EnsembleDeCases() {
}

template<class ImplementationInterne>
EnsembleDeCases<ImplementationInterne>::EnsembleDeCases(const EnsembleDeCases &edc) : ImplementationInterne(edc) {
}

template<class ImplementationInterne>
EnsembleDeCases<ImplementationInterne> &EnsembleDeCases<ImplementationInterne>::operator=(const EnsembleDeCases &edc) {
	if (this != &edc) {
		EnsembleDeCases<ImplementationInterne> temp(edc);
		swap(temp);
	}
	return *this;
}

template<class ImplementationInterne>
inline std::ostream &operator<<(std::ostream &os, const EnsembleDeCases<ImplementationInterne> &edc) {
	edc.display(os);
	return os;
}

template<class ImplementationInterne>
bool EnsembleDeCases<ImplementationInterne>::appliqueMouvement(const Mouvement<typename ImplementationInterne::Point> &m) {
	if ( (! libre(m.getOrigine1())) && (! libre(m.getOrigine2())) && libre(m.getDestination()) ) {
		retire(m.getOrigine1());
		retire(m.getOrigine2());
		ajoute(m.getDestination());
		return true;
	}
	return false;
}

template<class ImplementationInterne>
void EnsembleDeCases<ImplementationInterne>::retireMouvement(const Mouvement<typename ImplementationInterne::Point> &m) {
	ajoute(m.getOrigine1());
	ajoute(m.getOrigine2());
	retire(m.getDestination());
}

#endif // ENSEMBLEDECASES_H
