// Fichier libre de droits

#ifndef EXCEPTIONS_H
#define EXCEPTIONS_H

#include <exception>
#include <string>

#ifndef _DEBUG
//#define _DEBUG
#endif

struct CException : public std::exception {
	CException(const std::string & = "");
	virtual ~CException() throw();
	virtual const char *what() const throw();
protected :
	std::string m_Message;
};

struct CAssertException : public CException {
	CAssertException(const std::string &, int, const std::string &);
};

struct CLoadingFailed : public CException {
	CLoadingFailed(const std::string &);
};

#ifdef _DEBUG
#define Assert(condition) if (!(condition)) throw CAssertException(__FILE__, __LINE__, "Condition non satisfaite\n\n" #condition)
#else // _DEBUG
#define Assert(condition)
#endif // _DEBUG

#endif // EXCEPTIONS_H
